#ifndef HASH_TABLE_H
#define HASH_TABLE_H

#if !defined(BLAKE2_H)
#define HAVE_SSE2
#include "thirdparty/blake2/blake2.h"
#include "thirdparty/blake2/blake2b.c"
#endif

typedef struct Key Key;
struct Key
{
  u16 U16[2];
};

typedef struct TableNode TableNode;
struct TableNode
{
  TableNode *next;
  String8 data;
  Key key;
};

typedef struct TableSlot TableSlot;
struct TableSlot
{
  TableNode *first;
  TableNode *last;
};

typedef struct Table Table;
struct Table
{
  Arena *arena;
  Arena *str8_arena;

  TableSlot *slots;
  u64 slots_count;
};

internal Table * hash_store_initialize(void);

internal Key hash_store_string8_to_key(Table *table, String8 data);

#endif
