#include "base.h"
#include "win32_platform.h"
#include "arena.h"
#include "string.h"
#include "hash_store.h"
#include "keywords.h"

#include "win32_platform.c"
#include "arena.c"
#include "string.c"
#include "hash_store.c"

int
main(void)
{
  Table *table = hash_store_initialize();
  u64 list_size = array_count(keywords);

  for (u64 idx = 0; idx < list_size; idx += 1)
  {
    Key key = hash_store_string8_to_key(table, keywords[idx]);
    String8 string = hash_store_string8_from_key(table, key);

    Translation trans = key.U16[0];

    printf("%.*s =\t %04x - %04x - %u\n",
           (i32) string.length, string.content, key.U16[0], trans,
           ((key.U16[0] == trans) ? 1 : 0)
    );
  }

  return 0;
};
